]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
- added %glib_compile_schemas
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
7982022e
ER
2# vim:ts=4 sw=4 noet ft=spec
3#
f51bfb2f
ER
4# PLD Linux rpm macros.
5# <http://www.pld-linux.org/>
d54662bf 6
2b05614d 7# can be used by builder script to check for version
98c5c988
ER
8%rpm_build_macros %(R="$Revision$"; RR="${R##: }"; echo ${RR%%?})
9
e05017c1 10%epoch 0
3241033b 11%x8664 x86_64 amd64 ia32e
e483e029 12%arm armv3l armv4b armv4l armv5teb armv5tel
9c404149 13
ba1fdedc 14# kernel compiler
345d14e5 15%kgcc %{__cc}
d2e1bc22 16%kgcc_package gcc
ba1fdedc 17
46763914 18# compiler version
69bcfbf3 19%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
de629430 20%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
46763914 21
69bcfbf3 22%__rm /bin/rm --interactive=never
36eccf0d 23
33040789 24# Build system path macros.
69bcfbf3
ER
25%__autoconf autoconf %{?debug:-Wall}
26%__automake automake -a -c -f --foreign
27%__autopoint autopoint --force
28
29# add parallel build flags: -jN
a5656a95 30#
11ecb0a1
ER
31# if you want to disable parallel build do:
32# echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
a5656a95 33#
11ecb0a1
ER
34%__make /usr/bin/make %{?_smp_mflags}
35%__scons /usr/bin/scons %{?_smp_mflags}
36%__waf /usr/bin/waf %{?_smp_mflags}
b8f83d42 37%__cmake /usr/bin/cmake
a5656a95
JR
38
39%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
40 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
f93109a0 41
83094b62 42%__gettextize { \
8a995cff 43 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 44 gettextize --copy --force --no-changelog; \
97589b6e 45 else \
3241033b 46 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
47 fi; \
48 if [ ! -f po/Makevars ]; then \
3241033b 49 cp -f po/Makevars{.template,}; \
8a995cff 50 fi; \
8a995cff 51}
f93109a0 52
53%__glib_gettextize glib-gettextize --copy --force
54%__gnome_doc_common gnome-doc-common --copy
fb59e475 55%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 56%__gtkdocize gtkdocize --copy
57%__intltoolize intltoolize --copy --force
c26f1b59 58%__libtoolize libtoolize --copy --force --install
33040789 59
751c2bdd
ER
60# topdir is where builder script lives,
61# fallback to old style if SPECS/SOURCES dirs were found.
62%_topdir %{expand:%%global _topdir %(
63 if [ -d SPECS -a -d SOURCES ]; then
64 # old style rpmdir: in topdir
df3151c2 65 pwd
751c2bdd
ER
66 elif [ -d ../SPECS -a -d ../SOURCES ]; then
67 # old style rpmdir: in subdir
df3151c2 68 cd ..; pwd
751c2bdd
ER
69 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
70 # if old style rpm dir exist, go with it
71 echo $HOME/rpm; \
72 elif [ -x ../builder -a ! -d ../builder ]; then
73 # relative new style rpmdir: in package dir
df3151c2 74 cd ..; pwd
751c2bdd
ER
75 elif [ -x builder -a ! -d builder ]; then
76 # relative new style rpmdir: in packages
df3151c2 77 pwd
751c2bdd
ER
78 elif [ -x packages/builder -a ! -d packages/builder ]; then
79 # relative new style rpmdir: packages dir in current dir
df3151c2 80 cd packages; pwd
751c2bdd
ER
81 else
82 # fallback to new style rpmdir
83 echo $HOME/rpm/packages
84 fi; \
85)}%_topdir
1052b4b8 86
751c2bdd
ER
87# if %{_topdir}/SPECS exists, it's old style structure
88%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
89%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
1052b4b8
ER
90
91# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
92# if they don't exist assume we are having custom topdir (which is not named as
93# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
df3151c2
ER
94# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
95%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
96%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
97%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
384e1b2b 98
81e450f7
ER
99# The number of cvs changelog entries kept when building package.
100%_buildchangelogtruncate 20
101
6a5eda77 102%dependencytracking %{nil}
3241033b 103
e5da9169
ER
104# Relations between package names that cause dependency loops
105# with legacy packages that cannot be fixed. Relations are
106# specified as
107# p>q
108# where package p has a Requires: on something that package q Provides:
109#
110# XXX Note: that there cannot be any whitespace within the string "p>q",
111# and that both p and q are package names (i.e. no version/release).
112%_dependency_whiteout %{nil}
113
810fa5c4 114#-----------------------------------------------------------------
115#
116# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
117# BuildRequires: awk
118# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 119#
120# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 121# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
122# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
98e7f050 123# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
09a90176 124# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 125#
126# Regular expressions are supported, but to avoid some character be treated
127# as regular expression it must be escaped twice.
128
129%filter_out \
7b6f1112 130 for (i = 1; i in I; i++) { A=0; \
810fa5c4 131 for (f in F) { \
132 if (I[i] ~ "^" F[f] "$") A=1; \
133 }; \
134 if (!A) printf(I[i] FS); \
135 }
136
137%rpmcflags %(awk 'BEGIN {
138 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 139 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 140 %{filter_out}
141}')
142
143%rpmcxxflags %(awk 'BEGIN {
09a90176 144 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
145 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 146 %{filter_out}
147}')
148
98e7f050
AM
149%rpmcppflags %(awk 'BEGIN {
150 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
151 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
152 %{filter_out}
153}')
154
810fa5c4 155%rpmldflags %(awk 'BEGIN {
c05a0741 156 split("%{?optldflags}",I);
810fa5c4 157 split("%{?filterout_ld}",F)
158 %{filter_out}
159}')
160
25f52d1a 161# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
162# but, don't use it, better use gcc as linker
163%ld_rpmldflags %(awk 'BEGIN {
164 split("%{rpmldflags}",F);
165 for (f in F) {
166 s = F[f];
167 if (s ~ /^-Wl,/) {
168 s = substr(s,5);
169 gsub(/,/," ",s);
170 };
171 printf(s FS);
172 };
173}')
174
8ef644e5 175#-----------------------------------------------------------------
176#
177# Generate a command which cleans environment, leaving only the
178# most important variables.
179# If any spec requires any additional environment it should
180# redefine %_preserve_env in following manner:
181#
182# # ADDITIONAL_VAR is required because [a good reason here]
82d10503 183# %define _preserve_env ADDITIONAL_VAR
8ef644e5 184
57ba0f59 185%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
8ef644e5 186
bb597f2b
AM
187# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
188%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
0bdc88ec 189 split("%{?_preserve_env}", P);
a363d727
ER
190 for (i in P) {
191 p = P[i];
82d10503
ER
192 if (!ENVIRON[p] || d[p]) {
193 continue;
8ef644e5 194 }
82d10503
ER
195 d[p] = 1;
196 split(ENVIRON[p], V, "");
197 val = p "=";
198 for (j = 1; j in V; j++) {
199 v = V[j];
200 if (v == q)
201 v = qq;
202 else if (v == "\\"")
203 v = q2q;
204 else if (v == "\\\\")
205 v = "\\\\\\\\";
206 else
207 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
208 val = val "" v;
209 }
210 printf(val " ");
8ef644e5 211 }
212}')
213
9c404149 214#-----------------------------------------------------------------
9f4ce098 215%configure2_13 { \
9c404149
AM
216 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
217 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
218 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 219 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 220 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 221 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
98e7f050 222 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
8983c4c4
AM
223 %{?__cc:CC="%{__cc}" ; export CC ; } \
224 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 225 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 226 --host=%{_target_platform} \
9c404149
AM
227 --prefix=%{_prefix} \
228 --exec-prefix=%{_exec_prefix} \
229 --bindir=%{_bindir} \
230 --sbindir=%{_sbindir} \
231 --sysconfdir=%{_sysconfdir} \
232 --datadir=%{_datadir} \
233 --includedir=%{_includedir} \
234 --libdir=%{_libdir} \
235 --libexecdir=%{_libexecdir} \
236 --localstatedir=%{_localstatedir} \
237 --sharedstatedir=%{_sharedstatedir} \
238 --mandir=%{_mandir} \
239 --infodir=%{_infodir} \
b6c5da52 240 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 241 %{dependencytracking} \
9c404149
AM
242}
243
c4a85bd8 244%cmake \
d41caea6
ER
245%{?__cc:CC="%{__cc}"} \\\
246%{?__cxx:CXX="%{__cxx}"} \\\
247CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
248CFLAGS="${CFLAGS:-%{rpmcflags}}" \\\
249FFLAGS="${FFLAGS:-%{rpmcflags}}" \\\
250FCFLAGS="${FCFLAGS:-%{rpmcflags}}" \\\
251CXXFLAGS="${CXXFLAGS:-%{rpmcxxflags}}" \\\
252LDFLAGS="${LDFLAGS:-%{rpmldflags}}" \\\
c4a85bd8 253%{__cmake} \\\
8736ae44 254 -DCMAKE_VERBOSE_MAKEFILE=ON \\\
c4a85bd8 255 -DCMAKE_BUILD_TYPE=%{!?debug:Release}%{?debug:Debug} \\\
8736ae44
ER
256 -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \\\
257 -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
258 -DINCLUDE_INSTALL_DIR:PATH=%{_includedir} \\\
259 -DLIB_INSTALL_DIR:PATH=%{_libdir} \\\
260 -DSHARE_INSTALL_PREFIX:PATH=%{_datadir} \\\
261 -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
c27b3ff8 262%if "%{_lib}" == "lib64" \
c4a85bd8 263 -DLIB_SUFFIX=64 \\\
9d1e0c01 264%endif \
8736ae44 265 -DBUILD_SHARED_LIBS:BOOL=ON \\\
c4a85bd8 266%{nil}
89f4ca1f 267
89f4ca1f
ER
268%scons { \
269%{__scons} \
5c76736d
ER
270 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
271 CFLAGS="${CFLAGS:-%rpmcflags}" \
272 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
273 FFLAGS="${FFLAGS:-%rpmcflags}" \
98e7f050 274 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
5c76736d
ER
275 %{?__cc:CC="%{__cc}"} \
276 %{?__cxx:CXX="%{__cxx}"} \
277 libsuffix=%{_lib} \
278 prefix=%{_prefix} \
39b9534b
ER
279}
280
6339d32d 281# waf. see waf.spec
6339d32d 282%waf { \
6339d32d
ER
283CC="%{__cc}" \
284CXX="%{__cxx}" \
9e244007 285CPP="%{__cpp}" \
6339d32d
ER
286CFLAGS="%{rpmcflags}" \
287CXXFLAGS="%{rpmcxxflags}" \
288%{__waf} \
6339d32d
ER
289}
290
4a6b0d54 291#----------------------------------------------------------------
9bacbb5b 292#%configure_cache 0
fe6c4bdd 293%configure_cache_file %{buildroot}.configure.cache
73f832b3 294
e84cd836 295%configure {./configure \
4a6b0d54
AF
296 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
297 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 298 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 299 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 300 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
98e7f050 301 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
8983c4c4
AM
302 %{?__cc:CC="%{__cc}"} \
303 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 304 --host=%{_target_platform} \
4a6b0d54
AF
305 --build=%{_target_platform} \
306 --prefix=%{_prefix} \
307 --exec-prefix=%{_exec_prefix} \
308 --bindir=%{_bindir} \
309 --sbindir=%{_sbindir} \
310 --sysconfdir=%{_sysconfdir} \
311 --datadir=%{_datadir} \
312 --includedir=%{_includedir} \
313 --libdir=%{_libdir} \
314 --libexecdir=%{_libexecdir} \
315 --localstatedir=%{_localstatedir} \
316 --sharedstatedir=%{_sharedstatedir} \
317 --mandir=%{_mandir} \
318 --infodir=%{_infodir} \
b6c5da52 319 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 320 %{dependencytracking} \
9bacbb5b 321 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
322}
323
611a25d5 324# Simple macros to simplify adding bconded options to configure scripts.
325# Each macro requires bcond name and accepts optional option name, if option
326# isn't specified bcond name is used as option name. Options returning
327# --with and --enable also allow third argument which will be added as value
328# ( --with-option=value or --enable-option=value ) in case or positive
329# condition, but won't be added otherwise ( nothing or just --disable-option ).
330
331# Requirements:
332# BuildRequires: rpmbuild(macros) >= 1.527
333
334# Usage example:
335# %{__enable bcond} - returns --enable-bcond iff build condition is set
336# %{__disable bcond option} - returns --enable-option iff bcond is not set
337# %{__enable_disable bcond option value} - returns --enable-option=value if
338# bcond is set, returns --disable-option otherwise
339
340# expand bconds to --enable-something and --disable-something
341%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
342%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
343%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
344
345# same as above, but condition inverted
346%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
347%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
348%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
349
350# expand bconds to --with-something and --without-something
351%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
352%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
353%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
354
355# same as above, but condition inverted
356%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
357%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
358%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
359
360#-----------------------------------------------------------------
361
b3b1397b
ER
362# overload to insert debuginfo package
363%prep \
364%if 0%{?_enable_debug_packages}\
365%{debug_package}\
366%endif\
367%%prep\
368%{nil}
369
9c404149 370# Location of autoconf macros
ef7d5e14 371%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
9c404149 372
e2804f99 373# Location of omf files
7f0f4a79 374%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
e2804f99 375
e987a186 376# Location of pkgconfig files
9a4e877a 377%_pkgconfigdir /usr/%{_lib}/pkgconfig
36219c36
JB
378# noarch pkgconfig files
379%_npkgconfigdir /usr/share/pkgconfig
e987a186 380
486b0b5f 381# Location of desktop files
382%_desktopdir /usr/share/applications
86dff2d0 383%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 384
481463e9 385# Location of pixmaps for applnk/desktop files
e1f0a822 386%_pixmapsdir /usr/share/pixmaps
9c404149 387
481463e9 388# Location of themable icons for applnk/desktop files
b36c8e2a 389%_iconsdir /usr/share/icons
390
e987a186
JB
391# Location of fonts directories
392%_fontsdir /usr/share/fonts
393
b3282f3f 394# Location of Gtk and associated libraries documentation
fe6c4bdd 395%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 396
fc4d7771 397# Location of KDE documentation
fe6c4bdd 398%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 399
5869828c 400# unsermake script
401%__unsermake /usr/share/unsermake/unsermake
402
9c404149 403# Current date
8cf161e2 404%date %(LC_ALL=C date +"%a %b %d %Y")
9c404149 405
9c404149
AM
406# Example files, programs, scripts...
407%_examplesdir /usr/src/examples
408
c8f7e820 409# Alternative kernel type/version
261729d9 410%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
c8f7e820 411
8377d27d 412# The directory holding Linux kernel sources
261729d9 413%_kernelsrcdir /usr/src/linux%{_alt_kernel}
8377d27d 414
c0fe61f0
ER
415# SysV-style initscripts dir
416%_initddir /etc/rc.d/init.d
417
9c404149 418# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 419%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 420
590bc1db 421# Bootstrap release macros.
422# Usage:
423# %bcond_with bootstrap
424# Release: %{bootstrap_release 1}
425#
426# Package will have release 1 if built normally,
427# and release 0.zzz.bootstrap if built with bootstrap
428%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
429
c924d9d8
ER
430# -n drm to generate kernel%{_alt_kernel}-drm dependency
431%releq_kernel(n:) %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
432%releq_kernel_up(n:) %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
433%releq_kernel_smp(n:) %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
8bf3719d 434
c924d9d8 435# -s post to generate Requires(post) dependency
63d9963a
ER
436%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
437%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
438%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
8bf3719d 439
410df6e8
ER
440# Requires name = version-release
441%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
8cf161e2 442# Requires: name = version
91d2f1eb 443%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
8cf161e2 444# Requires: name = version (version based on querying package %2)
0d3e64c0 445%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
01a9f990 446
90c674d3
JR
447# Requires: name >= version
448%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
449# Requires: name >= version (version based on querying package %2)
450%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
451
c94807f3 452%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
b9d5d440 453
454# kernel version-release handling
95125403 455%__kernel_ver %{expand:%%global __kernel_ver %( \\
acac3049 456 Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
95125403
ER
457 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
458 echo ${Z:-ERROR}; \\
1a7d3518 459)}%__kernel_ver
95125403 460
c94807f3
ER
461%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
462%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
463%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
464%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
87be1cf0 465
6262f001
ER
466# `uname -r` to be used in @release field
467%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
468
e00dd7f6 469# sgml macros
3241033b
ER
470%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
471%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
472%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
473%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
474%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
475%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 476%docbook_sgmlcat_fix() { for l in \
477'' \
478' -- default decl --' \
479'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
480' -- hacks for opensp --' \
481'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
482'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
483'' \
484; do echo $l; done >> %1 \
485}
486
eea64748
ER
487# vim - "
488
4f044018
ER
489# minimum file size needed for compressed documents.
490# just smaller files than this get larger when compressed.
a88ae20f
ER
491# some stats:
492# - 0 byte file compressed was 25 bytes .gz
493# - 39 byte file was compressed as 57
494# - with test/test.spec@man 158 byte file was compressed also 158
495%_min_compress_bytes 159
4f044018 496
9c404149
AM
497#-----------------------------------------------------------------
498# find and gzip all files in %{_mandir} and %{infodir}
499#
500# Requires: xargs, find
501#
502#%no_install_post_compress_docs 1
503%__spec_install_post_compress_docs { \
53d5af13 504%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
4e10ec06 505 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 506 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 507 echo "Compress man pages: $i"; \
4f044018
ER
508 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
509 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
6375241c
ER
510 find $RPM_BUILD_ROOT$i -type l | while read a; do \
511 m=$(readlink $a); \
512 rm -f $a; \
513 echo .so ${m##*/} > $a; \
514 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
515 done; \
4f044018 516 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
9c404149
AM
517 fi; \
518 done; \
728ad671
JB
519 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
520 echo "Compress info pages: %{_infodir}"; \
521 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
522 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
523 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
4e10ec06 524 fi; \
53d5af13 525}; __spec_install_post_compress_docs } }
9c404149
AM
526
527#-----------------------------------------------------------------
528# Strip executable binaries and shared object files
529#
530# Requires: find, awk, strip, cut, xargs
531#
a2ad2754
JB
532# Special macros which affect this process:
533#%no_install_post_strip 1 # disable stripping at all
534#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
535#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
536#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
537#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
538#
9c404149 539%__spec_install_post_strip {%{!?debug: \
53d5af13 540%{!?no_install_post_strip:__spec_install_post_strip() { \
98a06bad 541if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748
ER
542 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
543 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
544 if [ "$modulelist" ]; then \
545 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 546 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34
ER
547 echo "$modulelist" | xargs -l512 chmod u+w; \
548 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
549 echo "DONE"; \
550 fi; \
eea64748 551 fi; \
0ac49134 552 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
553 if [ -n "$filelist" ]; then \
554 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
555 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
556 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 557 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 558 if [ -n "$elfexelist" ]; then \
4d5370ac 559 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
f89ccb5f
JB
560 chmod u+w $elfexelist; \
561 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
562 echo "DONE"; \
563 fi; \
564 if [ -n "$elfsharedlist" ]; then \
4d5370ac 565 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
f89ccb5f
JB
566 chmod u+w $elfsharedlist; \
567 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
568 echo "DONE"; \
569 fi; \
570 if [ -n "$archiveslist" ]; then \
4d5370ac 571 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
f89ccb5f
JB
572 chmod u+w $archiveslist; \
573 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
574 echo "DONE"; \
575 fi; \
98a06bad 576 fi; \
0ac49134
ER
577 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
578 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
579 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 580 if [ -n "$filelist_all" ]; then \
4d5370ac 581 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 582 chmod u+w $filelist_all; \
f89ccb5f 583 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 584 echo "DONE"; \
9c404149 585 fi; \
f89ccb5f 586 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 587 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 588 chmod u+w $filelist_unneeded; \
f89ccb5f 589 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 590 echo "DONE"; \
8f74418b 591 fi; \
f89ccb5f 592 if [ -n "$filelist_debug" ]; then \
4d5370ac 593 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 594 chmod u+w $filelist_debug; \
f89ccb5f 595 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 596 echo "DONE"; \
9f0d4f36 597 fi; \
53d5af13 598fi; }; __spec_install_post_strip } } }
3241033b 599
fc5d7e20 600#-----------------------------------------------------------------
601# remove all RPATH from executable binaries and shared object files
602#
603# Requires: find, awk, cut, xargs, chrpath, uname
604#
a2ad2754
JB
605# Special macros which affect this process
606#%no_install_post_chrpath 1 # disable chrpath at all
607#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
608#
fc5d7e20 609%__spec_install_post_chrpath {%{!?debug: \
53d5af13 610%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
9f0d4f36 611if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 612 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 613 if [ -n "$files" ]; then \
d5517264 614 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 615 fi; \
98a06bad 616 if [ -n "$objs" ]; then \
4d5370ac 617 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
618 echo "$objs" | \
619 while read file; do \
620 rpath= ; \
621 chmod u+w "$file"; \
5541bf26 622 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
eda6b510
AM
623 case $dir in \
624 '$ORIGIN' ) \
625 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
626 else rpath="$rpath:$dir" ; fi ; \
627 continue ; \
628 ;; \
629 esac ; \
f9abaddb
AM
630 newdir=$(readlink -m "$dir"); \
631 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
98a06bad
ER
632 case $dir in \
633 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
634 echo "remove-rpath: $dir in $file"; \
635 ;; \
636 * ) \
637 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
638 else rpath="$rpath:$dir" ; fi ; \
639 ;; \
640 esac ; \
641 done ; \
642 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
643 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
644 done; \
645 fi; \
53d5af13 646fi; }; __spec_install_post_chrpath } } }
3241033b 647
611a25d5 648# vim: "
649
d366d7e0
AM
650#-----------------------------------------------------------------
651# Find all shared object files with unresolved symbols. Warn
652# and terminate if any found (termination can be turned off by define).
653#%no_install_post_check_so 1
ff8c88f6 654#%skip_post_check_so libwithunresolvedok.so.*
e067aec9 655#
656# NOTE: define skip_post_check_so only if such library really requires
657# unresolved symbols and always leave a comment why it is required:
658# # executable provides symbols foo, bar for those libraries:
659# %define skip_post_check_so libwithoutfoo.so.* libwithoutbar.so.*
660#
d366d7e0 661%__spec_install_post_check_so { \
229037b6
ER
662__spec_install_post_check_so() { \
663 fail=0; \
664 printf "Searching for shared objects with unresolved symbols..."; \
665 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
666 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; %{?skip_post_check_so:split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "Library marked with skip_post_check_so, ignoring errors.\n"; exit(0); } } } exit(1); } } ' || fail=1 ; \
667 done ; \
668 echo " DONE"; \
669 %{!?no_install_post_check_so:return $fail;} \
d366d7e0
AM
670}; __spec_install_post_check_so }}
671
d72c185f 672#-----------------------------------------------------------------
ccb8ae8d 673# Find and gzip all kernel modules
674#
675# Requires: find
676#
fe6c4bdd 677#%no_install_post_compress_modules 1
ccb8ae8d 678%__spec_install_post_compress_modules { \
53d5af13 679%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
f3bfe4ac 680 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
f3bfe4ac 681 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
682 if [ "$q" ]; then \
683 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
684 echo "$q" | xargs -r %{__gzip} -9nf; \
685 echo "DONE"; \
686 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
687 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
688 fi; \
3241033b 689 fi; \
53d5af13 690}; __spec_install_post_compress_modules } }
9c404149 691
ef64802f
ER
692# Remove common Perl files we don't package
693%__spec_install_post_perl_clean {\
694%{!?no_install_post_perl_clean: \
695%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
696} }
697
83094b62 698#-----------------------------------------------------------------
0e4cb4dd 699# Update GConf2 schemas
83094b62 700#
701# Requires: GConf2
702#
46885239 703%gconf_schema_install() \
307ac6c9
ER
704 umask 022; \
705 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
706 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
f27cf2fd 707%{nil}
46885239 708
709%gconf_schema_uninstall() \
24336a54 710if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
3241033b 711 umask 022; \
24336a54
ER
712 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
713 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 714fi; \
f93109a0 715%{nil}
716
717#-----------------------------------------------------------------
718# Update desktop MIME database
c0a4caa0 719# requires: desktop-file-utils
c3bcd10e 720%update_desktop_database() {{ \
f93109a0 721 umask 022; \
fb59e475 722 /usr/bin/update-desktop-database -q; \
c00bf95c
MB
723};} \
724%{nil}
f93109a0 725
c3bcd10e
ER
726%update_desktop_database_post %update_desktop_database
727
728%update_desktop_database_postun() {{ \
f27cf2fd 729if [ "$1" = "0" ]; then \
c00bf95c 730 %update_desktop_database \
f27cf2fd 731fi; \
c00bf95c
MB
732};} \
733%{nil}
f93109a0 734
fb59e475 735#-----------------------------------------------------------------
736# Update shared MIME info database
737# requires: shared-mime-info
738#
c3bcd10e 739%update_mime_database() {{ \
fb59e475 740 umask 022; \
741 /usr/bin/update-mime-database %{_datadir}/mime; \
c00bf95c
MB
742};} \
743%{nil}
fb59e475 744
745#-----------------------------------------------------------------
746# Update icon cache
747# requires: gtk+
748#
c3bcd10e 749%update_icon_cache() {{ \
fb59e475 750 umask 022; \
072f4b80 751 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
c00bf95c
MB
752};} \
753%{nil}
fb59e475 754
f93109a0 755#-----------------------------------------------------------------
756# Update scrollkeeper database
757# requires: scrollkeeper
758#
759%scrollkeeper_update_post() \
f93109a0 760 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 761%{nil}
f93109a0 762
763%scrollkeeper_update_postun() \
f27cf2fd 764if [ "$1" = "0" ]; then \
f93109a0 765 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 766fi; \
f93109a0 767%{nil}
768
c9704b95
MB
769#-----------------------------------------------------------------
770# Compile GSettings schemas
771# requires: glib2 >= 1:2.26.0
772#
773%glib_compile_schemas() {{ \
774 umask 022; \
775 /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas; \
776};} \
777%{nil}
778
9c404149
AM
779#-----------------------------------------------------------------
780# post %install sequence:
781# - autodeps exceptions
782# - compress all man and info pages,
783# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 784# - compress kernel modules if any
9c404149
AM
785
786###################################################################
787# Requires/Provides automation
3e202b06 788# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
338726a6 789#
2892b5df
JB
790%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
791%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
792%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
793%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
794%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
c94807f3 795
338726a6
JB
796#%_noautocompressdoc %{nil}
797#
8f74418b
MM
798%_missing_doc_files_terminate_build 1%{nil}
799%_unpackaged_files_terminate_build %{nil}
8781dc74 800# (X)emacs support
d77dcb61 801%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
c94807f3
ER
802%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
803%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
25043cd4 804
02b58f60
JK
805%__php_provides %{nil}
806%__php_requires %{nil}
807%__perl_provides %{nil}
808%__perl_requires %{nil}
fa3497cd 809%__mono_provides %{nil}
810%__mono_requires %{nil}
25043cd4
AF
811
812# Perl specific macro definitions.
c94807f3
ER
813%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
814%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
815%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
816%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
817%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
818%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
25043cd4 819
45c00b39 820# Ruby
c94807f3
ER
821%__ruby /usr/bin/ruby
822%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
823%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
824%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
825%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
826%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
827%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
828%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
751cfc9e 829%ruby_rdocdir /usr/share/rdoc
c94807f3 830%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
669604db
ER
831%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
832%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 833
7ccf7643 834%php_pear_dir /usr/share/pear
7813c433 835%php_data_dir /usr/share/php
c94807f3
ER
836%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
837%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
838%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
25043cd4 839
0c5d1b9b 840# extract php/zend api versions
c94807f3 841%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
e0d35dd1 842%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
c94807f3
ER
843%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
844%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
845%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
846%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
847%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
d9ca5910
ER
848%_zend_zts %{expand:%%global _zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%_zend_zts
849# "_ts" if ZTS enabled, empty otherwise
850%zend_zts %{expand:%%global _zend_zts_%{?_zend_zts} 1}%{?_zend_zts_1:_ts}
c1b2705c
ER
851
852# helper macro
f952c0f3 853%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
854
855# macros for public use
856# for php extensions (php-pecl)
68b68193 857%requires_php_extension %{__php_api_requires modules_api php_api_version} \
415f4a1a 858%{__php_api_requires zend_module_api} \
f952c0f3 859%{__php_api_requires -v %php_major_version debug php_debug} \
e2bc6159 860%{__php_api_requires -v %php_major_version thread-safety _zend_zts}
68b68193 861
c1b2705c
ER
862# for zend extensions
863%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 864%{__php_api_requires zend_extension_api} \
f952c0f3 865%{__php_api_requires -v %php_major_version debug php_debug} \
e2bc6159 866%{__php_api_requires -v %php_major_version thread-safety _zend_zts}
c1b2705c 867
934c685f
ER
868# for php pdo modules (php-pecl-PDO_*)
869%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
870
6c3b8203
ER
871# for using PHP post scripts. for PHP >= 5.0
872%php_webserver_restart \
873[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
578e7794 874[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
8e2cfc36 875if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
876 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
877 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
878 %service -q php-fcgi restart \
879 fi \
880fi \
8e2cfc36
ER
881if [ -x /etc/rc.d/init.d/php-fpm ]; then \
882 %service -q php-fpm restart \
883fi \
6c3b8203
ER
884%{nil}
885
886# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
887%php4_webserver_restart \
888[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
578e7794 889[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
8e2cfc36 890if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
891 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
892 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
893 %service -q php-fcgi restart \
894 fi \
895fi \
6c3b8203
ER
896%{nil}
897
578e9248 898# X.org helper macros
434ab5a2
ER
899%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
900%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
901
c94807f3
ER
902%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
903%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
904%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
905%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
906%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
611a25d5 907# vim: '
578e9248 908
434ab5a2 909%requires_xorg_xserver_extension \
97486460
AM
910%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
911%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
912%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
913%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
434ab5a2
ER
914%{nil}
915
916%requires_xorg_xserver_xinput \
97486460
AM
917%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
918%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
919%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
920%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
434ab5a2
ER
921%{nil}
922
923%requires_xorg_xserver_font \
97486460
AM
924%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
925%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
926%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
927%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
434ab5a2
ER
928%{nil}
929
930%requires_xorg_xserver_videodrv \
97486460
AM
931%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
932%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
933%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
934%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
434ab5a2 935%{nil}
578e9248 936
15d7cc4a
ER
937# TCL specific macro definitions.
938# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
939%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
940%tcl_sitearch %{_libdir}/tcl%{tcl_version}
941%tcl_sitelib %{_datadir}/tcl%{tcl_version}
942
25043cd4
AF
943# Python specific macro definitions.
944# python main version
2383a9da 945%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
25043cd4
AF
946
947# directories
2383a9da 948%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
3241033b 949%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 950%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 951%py_incdir /usr/include/python%{py_ver}
7ccf7643 952%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 953%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 954%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
955
956# pure python modules compilation
3241033b 957%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 958
3241033b 959%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
960
961# Software written in Python language require Python with main version
e63cd81d 962%pyrequires_eq() Requires: %1
25043cd4 963
4bf34b55
AF
964# Python 3.x
965# python main version
e9f00395 966%__python3 python3
4bf34b55
AF
967%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
968
969# directories
970%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
971%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
972%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
973%py3_incdir /usr/include/python%{py3_ver}
974%py3_sitedir %{py3_libdir}/site-packages
975%py3_sitescriptdir %{py3_scriptdir}/site-packages
976%py3_dyndir %{py3_libdir}/lib-dynload
977
978# pure python modules compilation
979%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
980
981%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
982
f12c2314 983# Hardlink binary identical .pyc and .pyo files
f12c2314 984%__spec_install_post_py_hardlink {\
53d5af13 985%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f35a1d62
ER
986local a b c=0 t=0; \
987if [ -d "$RPM_BUILD_ROOT" ]; then \
988 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
989 while read a; do \
990 b="${a%.pyc}.pyo"; \
991 if cmp -s "$a" "$b"; then \
992 ln -f "$a" "$b"; \
993 c=$((c + 1)); \
994 fi; \
995 t=$((t + 1)); \
996 done < __rpm_pyc; \
997 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
998 rm -f __rpm_pyc; \
999fi; \
53d5af13 1000}; __spec_install_post_py_hardlink } }
f12c2314 1001
9227b3f9 1002# remove python sources, so that check-files won't complain
f12c2314 1003%py_postclean() \
0f82e280 1004for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 1005 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
1006done \
1007%{nil}
1008
4bf34b55
AF
1009%py3_postclean() \
1010for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
1011 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
1012done \
1013%{nil}
1014
0fc5cff8 1015# depmod macro
1016%depmod() { \
f6148427 1017umask 022; \
0fc5cff8 1018if [ -e /boot/System.map-%1 ]; then \
3241033b 1019 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 1020else \
3241033b
ER
1021 if [ -e /boot/System.map ]; then \
1022 /sbin/depmod -a -F /boot/System.map %1; \
1023 else \
1024 /sbin/depmod -a %1; \
1025 fi \
0fc5cff8 1026fi; \
1027}
1028
2afc6e64 1029# XMMS specific macros
c94807f3
ER
1030%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
1031%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
1032%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
1033%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1034%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1035%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1036%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1037%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1038%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1039%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1040
eb41c1ce 1041%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_target_base_arch
d1537778 1042
848c0d68 1043# user/group checking macros
1044#
1045# Usage:
1046# %userremove myuser
1047#
1048%userremove /usr/lib/rpm/user_group.sh user del
1049%groupremove /usr/lib/rpm/user_group.sh group del
1050#
1051# Usage:
1052# if %usertestrm myuser; then
1053# /usr/sbin/userdel -r myuser
1054# Note:
1055# use these macros only if you need to call userdel/groupdel with
1056# a non-standard option or take an extra action; otherwise use the
1057# %userremove/%groupremove macros
1058#
1059%usertestrm /usr/lib/rpm/user_group.sh user testrm
1060%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
1061# user group membership management macros
1062#
1063# Usage:
efbc7726 1064# %addusertogroup [-q] myuser agroup
08d9b1f6 1065#
efbc7726
ER
1066# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1067#
1068# Requirements:
1069# BuildRequires: rpmbuild(macros) >= 1.515
2b29e157
ER
1070%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1071%{nil}
72fcfcb3 1072
1073# banner support (useful in {pre,post}{,un} and triggers)
1074#
1075# Usage:
aa41c920 1076# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 1077# the banner text, the banner text
aa41c920
ER
1078# the banner text, and following line
1079#EOF
1080# You can use any form of here-document, <<'EOF' <<-EOT will do.
1081# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1082#
72fcfcb3 1083# -a - append to the banner
a8b9562a 1084# -e - send to stderr instead of stdout
628754cb 1085# -n - no show banner (overrides -t)
1086# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
276a7b45
ER
1087#
1088# Tests:
1089# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1090# rpm -E 'date | %banner -e banner' > m; sh -x m
1091#
afb54f6c 1092%banner(aent:) ( \
1b334fe4 1093RPM_SCRIPTVERBOSITY=5 \
1094[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1095if [ -x /usr/bin/banner.sh ]; then \
aa41c920 1096 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 1097else \
a8b9562a 1098 CMD="cat%{-e: >&2}" \
1b334fe4 1099fi \
276a7b45
ER
1100eval $CMD %{?2:%2}%{?3: %3}) \
1101%{nil}
628754cb 1102
990bd03f 1103# useradd/groupadd macros
4c73bc69 1104# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
1105#
1106# Usage:
1107# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1108# [-g initial_group] [-G group[,...]] login
1109#
1110# -u uid. REQUIRED
1111# -g gid/group. REQUIRED
1112# -s defaults to /bin/false
1113# -d defaults to /usr/share/empty
1114# -c No default
1115# -r is accepted but ignored (it's always set)
6bd4c218 1116# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
1117# rpm specific flags
1118# -P package name. defaults to %{name}
1119#
90627280 1120%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
1121%{!-u:%{error:useradd: Required argument -u missing}} \
1122%{!-g:%{error:useradd: Required argument -g missing}} \
1123%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
1124if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1125 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1126 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1127 exit 1 \
1128 fi \
1129else \
1130 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1131 /usr/sbin/useradd \\\
b5a7d552 1132 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
1133 -u %{-u*} \\\
1134 -r \\\
1135 -d %{-d*}%{!-d:/usr/share/empty} \\\
1136 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 1137 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
1138 -g %{-g*} \\\
1139 %{-M} \\\
1140 %{-G:-G %{-G*}} \\\
1aac682a 1141 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 1142 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280 1143fi;
611a25d5 1144# vim: "
90627280 1145
90627280
ER
1146# Usage:
1147# %groupadd [-P package] [-g gid] group
1148#
1149# -g gid. REQUIRED
1150#
1151# Sample:
1152# %groupadd -P %{name}-base -g %{gid} %{name}
1153
1154%groupadd(g:P:rfo) \
9ba02ba9
ER
1155%{!-g:%{error:groupadd: Required argument -g missing}} \
1156%{!?1:%{error:groupadd: Required parameter group missing}} \
637962e6 1157if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
90627280
ER
1158 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1159 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1160 exit 1 \
1161 fi \
1162else \
1163 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 1164 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 1165 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 1166fi;
7cb77741 1167
7c50f037 1168# webapp macros
4c73bc69 1169# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
1170#
1171# The config is installed/removed inside trigger, this means that you can any
1172# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 1173# updated. if you don't need the config for various reason for specific
35663282
ER
1174# webserver, just remove the symlink from config directory using webapp
1175# program. the trigger will not recreate the symlink on upgrades. In other
1176# words the config is linked to webserver config directory on first install of
1177# PACKAGE or WEBSERVER.
1178#
7c50f037
ER
1179# Add package's webserver config to webserver webapps dir.
1180# Usage:
aea687a7 1181# %webapp_register [-f] WEBSERVER WEBAPP
35663282 1182#
aea687a7 1183%webapp_register(f) \
35663282 1184%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
aea687a7 1185if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
35663282
ER
1186 /usr/sbin/webapp register %1 %2\
1187fi\
694a8f2e 1188# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 1189if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 1190 %{expand:%service -q %%1 reload}\
35663282
ER
1191fi\
1192%{nil}
1193
1194# Remove package's config from webserver webapps dir.
35663282 1195# Usage:
531c0efc
ER
1196# %webapp_register [-f] WEBSERVER WEBAPP
1197%webapp_unregister(f) \
35663282
ER
1198%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1199# remove link if either of the packages are gone \
5d3a09a3 1200if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
df979130 1201 /usr/sbin/webapp unregister %1 %2\
16897aea 1202 %{expand:%service -q %%1 reload}\
35663282
ER
1203fi \
1204%{nil}
1205
462b26fa 1206# service macro.
4c73bc69 1207# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
1208#
1209# calls usual service restart on package %post, but skips the restart if
1210# administrator has disabled automatic service restarts in either global
1211# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1212#
462b26fa 1213# Usage:
7377b5ca 1214# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 1215#
a0bbe604 1216# -q be silent when service isn't started (for scriplets restaring other package's services)
7377b5ca 1217# -n NOOP mode, do not actually restart service
462b26fa 1218#
7377b5ca
ER
1219# Requirements:
1220# BuildRequires: rpmbuild(macros) >= 1.268
1221# Requires: rc-scripts
1222# -n option:
1223# BuildRequires: rpmbuild(macros) >= 1.450
1224%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62
ER
1225
1226
f9aa75bf
ER
1227# Java macros. based on jpackage macros.java
1228#
1229# Root directory where all Java VMs/SDK/JREs are installed.
2d4659a1 1230%_jvmdir %{_libdir}/jvm
f9aa75bf
ER
1231
1232# Root directory where all Java VMs/SDK/JREs expose their jars
2d4659a1 1233%_jvmjardir %{_libdir}/jvm-exports
f9aa75bf
ER
1234
1235# Root directory for all Java VM/SDK/JRE's private things.
1236%_jvmprivdir %{_libdir}/jvm-private
1237
1238# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
2d4659a1 1239%_jvmlibdir %{_libdir}/jvm
f9aa75bf
ER
1240
1241# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1242%_jvmdatadir %{_datadir}/jvm
1243
1244# Root directory for all configurations parts of Java VM/SDK/JRE's
1245%_jvmsysconfdir %{_sysconfdir}/jvm
1246
1247# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
f5ed4276 1248%_jvmcommonlibdir %{_libdir}/jvm-common
f9aa75bf
ER
1249
1250# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
f5ed4276 1251%_jvmcommondatadir %{_datadir}/jvm-common
f9aa75bf
ER
1252
1253# Root directory for all common configurations parts of Java VM/SDK/JRE's
f5ed4276 1254%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
f9aa75bf
ER
1255
1256# Directory where arch-specific (JNI) version-independent jars are installed.
2d4659a1 1257%_jnidir %{_libdir}/java
f9aa75bf 1258
ed644e79
JK
1259
1260# JDK selection. Set this to name of the JDK implementation to use
1261# insead of the system default
1262#%use_jdk icedtea6
1263
1264# expands to the value with right jdk for BuildRequires header
1265# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1266# The requirement will not replace current 'default' JDK
1267%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1268
1269%buildrequires_jdk BuildRequires: %required_jdk
1270
1271%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
6aedae62 1272
e0e23dcd 1273%_javasrcdir %{_usrsrc}/java
1274
a9254650 1275%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
fe6c4bdd 1276%jar %{java_home}/bin/jar
ed644e79 1277%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
fe6c4bdd
ER
1278%javac %{java_home}/bin/javac
1279%javadoc %{java_home}/bin/javadoc
6aedae62 1280
fe6c4bdd 1281%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
6aedae62
ER
1282
1283%jpackage_script() \
3ca65b87
ER
1284install -d $RPM_BUILD_ROOT%{_bindir}\
1285cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
6aedae62
ER
1286#!/bin/sh\
1287#\
1288# %{name} script\
1289# JPackage Project <http://www.jpackage.org/>\
1290\
1291# Source functions library\
1292. %{_javadir}-utils/java-functions\
1293\
1294# Source system prefs\
3ca65b87 1295if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
fe6c4bdd 1296 . %{_sysconfdir}/java/%{name}.conf\
6aedae62
ER
1297fi\
1298\
1299# Source user prefs\
3ca65b87
ER
1300if [ -f $HOME/.%{name}rc ]; then\
1301 . $HOME/.%{name}rc\
6aedae62
ER
1302fi\
1303\
1304# Configuration\
1305MAIN_CLASS=%1\
1306BASE_FLAGS=%2\
1307BASE_OPTIONS=%3\
3ca65b87 1308BASE_JARS="%(echo %4 | tr ':' ' ')"\
6aedae62
ER
1309\
1310# Set parameters\
1311set_jvm\
3ca65b87
ER
1312set_classpath $BASE_JARS\
1313set_flags $BASE_FLAGS\
1314set_options $BASE_OPTIONS\
6aedae62
ER
1315\
1316# Let's start\
3ca65b87 1317run "$@"\
6aedae62
ER
1318EOF
1319
06f11871
ER
1320# jpackage 1.7
1321# Directory for maven depmaps
1322#
1323%_mavendepmapdir /etc/maven
1324%_mavendepmapfragdir /etc/maven/fragments
1325
1326#
1327# add_to_depmap adds an entry to the depmap. The arguments are:
1328#
1329# %1 the original groupid
1330# %2 the original artifact id
1331# %3 the version
1332# %4 the new groupid
1333# %5 the new artifactid
1334#
1335
1336%add_to_maven_depmap() \
1337install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1338cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1339<dependency>\
1340 <maven>\
1341 <groupId>%1</groupId>\
1342 <artifactId>%2</artifactId>\
1343 <version>%3</version>\
1344 </maven>\
1345 <jpp>\
1346 <groupId>%4</groupId>\
1347 <artifactId>%5</artifactId>\
1348 <version>%3</version>\
1349 </jpp>\
1350</dependency>\
1351\
1352EOF\
1353%{nil}
1354
1355#==============================================================================
1356#
1357# update_maven_depmap updates the main maven depmap
1358#
1359%update_maven_depmap() \
1360echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1361if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1362cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1363fi\
1364echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1365
02c5f99a 1366# JAVA macros specific for PLD
1367
1368# Directory for tomcat context configuration files
1369%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
06f11871 1370
89c2423f 1371# Tomcat cache path
1372%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1373
1374# Clear tomcat cache
1375# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1376#
1377# Usage:
1378# %%tomcat_clear_cache appname
1379#
e09b1b1b 1380# Call this script in %postun scriptlet. It will remove compiled jsps related to
89c2423f 1381# given app.
1382#
1383%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1384
59d3ebe9 1385# PEAR install macros
4c73bc69 1386# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1387#
1388# Usage:
f7ecf326 1389# %%pear_package_setup ...
dfce8b19 1390#
59d3ebe9 1391# -a # - also unpack SOURCE#. for PEAR bootstrapping
43d992d6 1392# -n FMT - create builddir with FMT, instead of default %%{pearname}-%%{version}
59d3ebe9 1393# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
f7ecf326
ER
1394# -D - pass -D to %setup (so the build dir is not removed)
1395# -c - register channel from local channel.xml file
11a40e7b 1396# -d - pass -d arg to pearcmd
dfce8b19
ER
1397#
1398# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1399# destination hierarchy. you should copy the tree to buildroot after
1400# patching/reorganizing with %%pear_package_install.
1401#
1402# additionally BUILDROOT is stripped from files and files are converted to UNIX
1403# line endings.
1404#
1405# the pear install process output is recorded to install.log, you should put it
8763f51e 1406# to %%doc for later debug or just for information.
dfce8b19
ER
1407#
1408# additionally additional-packages.txt is produced if it was detected that the
1409# package has optional dependencies. the file format is suitable of displaying
1410# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1411# automatically added for this file.
59d3ebe9
ER
1412
1413
1414# records install.log and transforms PEAR names to PLD Linux rpm package names.
1415%__pear_install_log \
1416tee install.log \
1417# make post message of optional packages \
5ad4663a 1418grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
59d3ebe9
ER
1419if [ -s optional-packages.txt ]; then \
1420 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1421else \
1422 rm -f optional-packages.txt \
1423fi \
1424%{nil}
1425
e98e79d4
ER
1426# Command invoking PEAR CLI
1427# Same as /usr/bin/pear, except we force GMT timezone
1428%__pear %__php -doutput_buffering=1 -dopen_basedir="" -dmemory_limit=-1 -ddate.timezone=GMT %{php_pear_dir}/pearcmd.php
59d3ebe9 1429
11a40e7b 1430%pear_install(a:d:n:zD) \
59d3ebe9 1431%__pear \\\
f7ecf326 1432 -c %{builddir}/pearrc \\\
dfce8b19 1433 -d doc_dir=/docs \\\
f7ecf326
ER
1434 -d temp_dir=/tmp \\\
1435 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
dfce8b19
ER
1436 -d bin_dir=%{_bindir} \\\
1437 -d data_dir=%{php_pear_dir}/data \\\
1438 -d test_dir=%{php_pear_dir}/tests \\\
11a40e7b 1439 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
dfce8b19 1440 install \\\
59d3ebe9 1441 --packagingroot=%{builddir} \\\
dfce8b19
ER
1442 --offline \\\
1443 --nodeps \\\
1444 %{-f:--force} \\\
67a089ff 1445 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
b872fad7 1446 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
67a089ff
ER
1447%{nil}
1448
1449# The main macro.
1450# using this macro will append optional-packages.txt to the nocompressdoc list
1451# as it's displayed to user after package install. and adding additional gzip
1452# dep is just waste ;)
11a40e7b 1453%pear_package_setup(a:d:n:zDc:) \
43d992d6 1454%define srcdir %{-n*}%{!-n:%{?_pearname}%{!?_pearname:%{pearname}}-%{version}} \
67a089ff
ER
1455%define builddir %{_builddir}/%{srcdir} \
1456%setup -q -c -T %{-D:-D} -n %{srcdir} \
a4b4c90f 1457%{-z:%{__tar} zxf %{S:0}; %{-a:%{__tar} zxf %{S:%{-a*}}}} \
67a089ff 1458%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
f7ecf326 1459%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
67a089ff 1460%pear_install \
59d3ebe9 1461%{-z:cd ..} \
a4b4c90f 1462%{__tar} --wildcards -zvxf %{S:0} package*.xml \
59d3ebe9 1463cat %{-z:$_N/}.install.log | %__pear_install_log \
208a11f6 1464%undos -f php,html,js,xml \
dfce8b19
ER
1465%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1466%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1467%{nil}
1468
7bef60e8 1469# Copies exctracted PEAR package structure and PEAR registry to buildroot.
4c73bc69 1470# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1471%pear_package_install() \
1472cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1473find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1474# help the developer out a little: \
1475if [ -f _noautoreq ]; then \
1476 echo "AutoReqdep detected:" \
1477 echo "_noautoreq $(cat _noautoreq)" \
1478fi \
1479%{nil}
1480
cc8d4be7
ER
1481# Print optional package info for pear packages
1482# Author: Elan Ruusamäe <glen@pld-linux.org>
1483# Usage:
1484# %post -p <lua>
1485# %%pear_package_print_optionalpackages
1486#
1487# Requirements:
1488# BuildRequires: rpmbuild(macros) >= 1.571
1489%pear_package_print_optionalpackages \
1490f = io.open("%{_docdir}/%{name}-%{version}/optional-packages.txt", "r") \
1491if f then \
1492 for l in f:lines() do print(l); end \
1493end \
1494%{nil}
1495
0d5dd00c
ER
1496
1497# Register OpenLDAP schema.
4c73bc69 1498# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1499#
1500# Usage:
1501# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1502#
1503# -d specify dependant schemas, separated by comma
1504#
1505%openldap_schema_register(d:) \
1506for schema in %*; do \
1507 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1508 %{__sed} -i -e " \
1509 /^include.*local.schema/{ \
1510 iinclude\\t $schema\
1511 } \
1512 " /etc/openldap/slapd.conf \
1513 fi \
1514done \
1515# enable dependant schemas \
1516if [ "%{-d*}" ]; then \
1517 %{__sed} -i -e ' \
1518 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1519 s/^#// \
1520 }' /etc/openldap/slapd.conf \
1521fi \
1522%{nil}
1523
1524# Unregister OpenLDAP schema.
4c73bc69 1525# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1526#
1527# Usage:
1528# %%openldap_schema_unregister %{schemadir}/horde.schema
1529#
1530%openldap_schema_unregister() \
1531for schema in %*; do \
1532 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1533 %{__sed} -i -e " \
1534 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1535 # for symmetry it would be nice if we disable enabled schemas in post, \
1536 # but we really can not do that, it would break something else. \
1537 " /etc/openldap/slapd.conf \
1538 fi \
1539done \
1540%{nil}
1541
b0bc2936 1542%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1543
dcc6baf7 1544
1545# Build modules for kernels 2.6
1546# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1547#
1548# Usage:
aa559e46 1549# %build_kernel_modules -m <modules> -C <directory>
dcc6baf7 1550#
1551# remember that proper Makefile is still required
1552# Options:
990bd03f 1553# -m <modules> (required) -- comma-separated list of modules to save,
dcc6baf7 1554# without .ko extension, may be placed in subdirectory
aa559e46 1555# -C <directory> -- change to <directory> before doing anything
dcc6baf7 1556# -p <arg>, -P <arg> -- arguments passeed to make scripts
5a81d83e 1557# -c -- do not execute make clean
dcc6baf7 1558# <additional arguments> -- all additional arguments will be passed to
1559# make modules
1560#
1561# Additional patching supported via here document. Try:
1562# %build_kernel_modules -m module <<'EOF'
1563# your patch script here
1564# EOF
1565# Don't use it unless patching depends on config options.
1566
1567# Developer note: don't touch it unless you know how to handle '\'.
1568# - \ in script expands to nothing
1569# - \\\ in script expands to \
566398b4 1570# - \\\ inside definition expands to nothing
dcc6baf7 1571# - \\\\\\\ inside definition expands to \
1572# - in last line \ has to touch arguments so arguments passing
1573# in new lines (using \) will be supported
1574
5a81d83e 1575%build_kernel_modules(p:P:m:C:c) \
dcc6baf7 1576%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1577 \
1578%define Opts \\\\\\\
1579%if "%{_target_base_arch}" != "%{_arch}" \\\
1580 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
88608ef7 1581 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
dcc6baf7 1582 %else \\\
1583 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1584 %endif \\\
1585%else \\\
88608ef7 1586 CC="%{kgcc}" \\\
dcc6baf7 1587%endif \
88608ef7 1588%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
dcc6baf7 1589 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1590 \
e364bc26 1591%{?-C:cd %{-C*}} \
dcc6baf7 1592compile() { \
ba9de9b2
ER
1593 local L="<" PATCH_SH; \
1594 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
dcc6baf7 1595 set -e -x \
730239f9 1596 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1597 \
730239f9 1598for cfg in ${cfgs:-dist}; do \
dcc6baf7 1599 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1600 \
c546f6fb 1601 rm -rf o \
ec8cb195 1602 install -d o/include/linux o/include/generated o/arch/powerpc/lib \
dcc6baf7 1603 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1604 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
ec8cb195
AM
1605 if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then \
1606 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
a2a36b0c 1607 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
ec8cb195
AM
1608 else \
1609 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1610 fi \
dcc6baf7 1611 \
1612 set +x \
1613 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1614 set -x \
1615 \
c768535c 1616 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
dcc6baf7 1617 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1618 %{-p*} %{-P*} \\\
1619 %{MakeOpts} \
1620 %else \
1621 install -d o/include/config \
1622 touch o/include/config/MARKER \
588f1b0b 1623 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
dcc6baf7 1624 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1625 %endif \
1626 \
5a81d83e 1627 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
dcc6baf7 1628 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
f635907b 1629 ${1+"$@"} \\\
5a81d83e 1630 M=$PWD %{MakeOpts}} \
f635907b 1631 \
dcc6baf7 1632 %{__make} -C %{_kernelsrcdir} modules \\\
1633 ${1+"$@"} \\\
1634 M=$PWD %{MakeOpts} \
1635 \
1636 for MODULE in {%{-m*},}; do \
1637 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1638 done \
1639done \
aa559e46 1640%{?-C:cd -} \
dcc6baf7 1641} \
1642compile %{*}\
1643%{nil}
1644
1645
1646# Install kernel modules built by %build_kernel_modules
1647# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1648#
1649# Usage:
1650# %install_kernel_modules -m <modules> -d <directory>
1651#
1652# Options:
990bd03f 1653# -m <modules> (required) -- comma-separated list of modules to install,
dcc6baf7 1654# without .ko extension, may be placed in subdirectory
1655# -d <directory> (required) -- in what subdirectory modules should be
1656# installed (eg. misc, kernel/drivers/net)
1657# -s <suffix> -- suffix to use when installing modules, useful when module
1658# with same name exists in kernel already
1659# -n <file> -- name of modprobe config file to use (without .conf extension)
00395cf1 1660# for defining aliases, only useful with -s
dcc6baf7 1661
1662%install_kernel_modules(m:d:s:n:) \
1663%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1664%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1665%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1666 \
1667%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1668%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
412786d1 1669 \
b279feda 1670__install_kernel_modules() { \
730239f9 1671local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1672 \
1673for MODULE in {%{-m*},}; do \
1674 [ -n "${MODULE}" ] || continue \
730239f9
ER
1675 for cfg in ${cfgs:-dist}; do \
1676 [ "$cfg" = smp ] && suf=smp || suf= \
1677 MNAME=${MODULE##*/} \
1678 install -D ${MODULE}-$cfg.ko \\\
1679 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b9460afb 1680 %{?-s:install -d %{ModprobeD}$suf \
730239f9
ER
1681 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1682 >> %{ModprobeD}$suf/%{-n*}.conf} \
1683 done \
dcc6baf7 1684done \
b279feda 1685} \
1686__install_kernel_modules \
dcc6baf7 1687%{nil}
1688
fa65356c 1689# patchset macros
4c73bc69 1690# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1691#
1692# Usage:
1693# %patchset_source -f <seq(1) format> <start> [<end>]
1694# %patchset_patch <start> [<end>]
1695#
1696# If <end> is omited, it is assumed to be <start>.
1697#
1698# For example in preamble:
1699# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1700# and in %prep:
1701# %patchset_patch 33 44
1702
1703# generate SourceX urls from range START STOP
1704# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1705# The sources start from 10000
e91610db 1706%patchset_source(f:b:) %(
44f733ef 1707 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1708 start=$(expr $base + %1);
1709 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1710 # we need to call seq twice as it doesn't allow two formats
1711 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1712 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1713 paste %{tmpdir}/__ps{1,2};
1714 rm -f %{tmpdir}/__ps{1,2};
962f9ecf
ER
1715) \
1716%{nil}
fa65356c
ER
1717
1718# apply sources from %patchset_source
1719# -p specify -pX for %patch line
1720# -b base offset: defaults to 10000
1721%patchset_patch(f:p:b:) %(
44f733ef 1722 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1723 start=$(expr $base + %1);
1724 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1725 echo ": patchset_patch %1%{?2: to %2}";
1726 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
962f9ecf
ER
1727) \
1728%{nil}
fa65356c 1729
5730b44b 1730# browser plugins v2
4c73bc69 1731# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1732#
1733# Usage:
1734# %browser_plugins_add_browser <name> -p <plugindir>
1735#
1736# <name> (required) -- name of the browser. usually %{name}.
1737# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1738# -b -- default blacklists
1739# -a <arch> override arch
5730b44b
ER
1740#
1741# Example:
1742# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1743
1744%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1745%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1746%update_browser_plugins /usr/sbin/update-browser-plugins || :
1747
02ebf70f 1748%browser_plugins_add_browser(p:b:a:) \
9efd458e 1749 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1750 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1751 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1752 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1753 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1754 %{-b:cat >> $blacklist_file %{-b*}} \
1755%{nil}
1756
ad17b654
ER
1757# Helper for LUA.
1758# split string separated by space into quoted list
1759#
4c73bc69 1760# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1761#
1762# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1763%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1764
1765# adjust /etc/shells by adding and removing shells from there
4c73bc69 1766# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1767#
1768# Usage:
d9b789d9
ER
1769# %post -p <lua>
1770# %lua_add_etc_shells /bin/sh /bin/pdksh
ad17b654 1771#
d9b789d9
ER
1772# %preun -p <lua>
1773# if arg[2] == 0 then
1774# %lua_remove_etc_shells /bin/bash /bin/rbash
1775# end
7377b5ca
ER
1776#
1777# Requirements:
d9b789d9
ER
1778# BuildRequires: rpmbuild(macros) >= 1.462
1779#
ad17b654 1780
d9b789d9 1781%lua_add_etc_shells() \
ad17b654
ER
1782t = {}\
1783f = io.open("/etc/shells", "r")\
1784if f then\
1785 for l in f:lines() do t[l]=l; end\
1786 f:close()\
1787end\
1788for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1789 if not t[s] then\
b8c0bc18 1790 print("Adding "..s.." to /etc/shells")\
ad17b654
ER
1791 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1792 end\
1793end\
1794%{nil}
1795
d9b789d9
ER
1796%lua_remove_etc_shells() \
1797t = {}\
1798f = io.open("/etc/shells", "r")\
1799if f then\
1800 for l in f:lines() do t[l]=l; end\
1801 f:close()\
1802end\
1803for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1804 print("Removing "..l.." from /etc/shells")\
1805 t[l] = nil\
1806end\
1807s=""\
1808for _, l in pairs(t) do\
1809 s=s..l.."\\n"\
1810end\
1811io.open("/etc/shells", "w"):write(s)\
1812%{nil}
1813
1814# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1815#
1816# Author: Elan Ruusamäe <glen@pld-linux.org>
1817#
1818# Usage:
1819# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1820# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1821#
1822# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1823#
1824# Requirements:
1825# BuildRequires: rpmbuild(macros) >= 1.429
1826#
1827%add_etc_shells(p) %{-p:<lua>}\
1828%{expand:%%lua_add_etc_shells %*}\
1829%{nil}
1830
ad17b654 1831%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1832%{-p:if arg[2] == 0 then}\
d9b789d9 1833%{expand:%%lua_remove_etc_shells %*}\
750e19f4 1834%{-p:end} \
ad17b654
ER
1835%{nil}
1836
75bd6249
ER
1837# Check syntax for Python files
1838#
1839# Author: Elan Ruusamäe <glen@pld-linux.org>
1840# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1841#
1842# Usage:
1843# %py_lint src
1844#
1845# Requirements:
1846# BuildRequires: python
1847# BuildRequires: rpmbuild(macros) >= 1.469
1848
1849%py_lint() \
1850__py_lint() { \
1851find "$@" -type f -name '*.py' | python -c ' \
1852import sys \
1853import compiler \
1854\
1855err = 0\
1856for f in sys.stdin: \
1857 fd = open(f.strip()) \
1858 c = fd.read() \
1859 fd.close() \
1860 try: \
1861 compiler.parse(c) \
1862 except SyntaxError, e: \
1863 print "py_lint: %s: %s" % (f.strip(), e) \
1864 err = err + 1\
1865\
1866if err: \
1867 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1868 sys.exit(1) \
1869else: \
1870 print >> sys.stderr, "py_lint: Found no syntax errors." \
1871' \
1872}; __py_lint %* \
1873%{nil}
1874
f602e4a0 1875# Undos files
1876#
1877# Author: Paweł Zuzelski <pawelz@pld-linux.org>
0217c63b 1878# Author: Elan Ruusamäe <glen@pld-linux.org>
f602e4a0 1879#
1880# Usage:
1881# %undos list_of_files
0217c63b
ER
1882# %undos -f EXT[,EXT]
1883# %undos -i -f EXT[,EXT]
1884#
1885# -f EXT[,EXT] - find(1) files by extensions
1886# -i - case insensitive file search
1887#
1888# Example:
1889# Un-DOS all *.js, *.css files
1890# %undos -f js,css
1891# Un-DOS all *.js, *.JS files
1892# %undos -f js -i
1893# undos all Makefiles
1894# %{__find} -name Makefile | xargs %undos
f602e4a0 1895#
1896# Requirements:
1897# BuildRequires: sed >= 4.0
81a64c94 1898# BuildRequires: rpmbuild(macros) >= 1.565
f602e4a0 1899
0217c63b 1900# NB: make sure this macro stays on one line
81a64c94
ER
1901# NB: make sure it includes newline escape
1902%undos(f:i) %{-f:%{__find} -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
1903%{nil}
f602e4a0 1904
2f79ae5a
ER
1905# Hook to register nagios object based plugins in Nagios NRPE daemon config.
1906#
1907# Author: Elan Ruusamäe <glen@pld-linux.org>
1908#
1909# Usage:
1910# -a NAME -- add command named NAME
1911# -d NAME -- remove command named NAME
1912# -f FILE -- specify plugin configuration FILE to extract command definition from
1913#
1914# Sample:
1915# %triggerin -- nagios-nrpe
1916# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1917#
1918# %triggerun -- nagios-nrpe
1919# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1920#
1921# Requirements:
f236a3c2 1922# Requires: grep
1923# Requires: sed >= 4.0
d7cee36f 1924# BuildRequires: rpmbuild(macros) >= 1.552
2f79ae5a 1925%nagios_nrpe(a:d:c:f:) {\
d7cee36f 1926 m=$(md5sum < /etc/nagios/nrpe.cfg); \
2f79ae5a 1927 %{-a:# on -a and config exists \
d7cee36f
ER
1928 if [ -f /etc/nagios/nrpe.cfg ]; then \
1929 if ! %{__grep} -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
1930 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
2f79ae5a
ER
1931 fi; \
1932 fi;} \
1933 %{-d:# on package remove, -d and config exists \
d7cee36f
ER
1934 if [ "$1" = "0" -a -f /etc/nagios/nrpe.cfg ]; then \
1935 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
2f79ae5a 1936 fi;} \
d7cee36f
ER
1937 if [ "$m" != "$(md5sum < /etc/nagios/nrpe.cfg)" ]; then \
1938 %service -q nrpe restart; \
1939 fi; \
2f79ae5a
ER
1940}%{nil}
1941
070aa9f4
ER
1942# Import or update Cacti template.
1943#
1944# Author: Elan Ruusamäe <glen@pld-linux.org>
1945#
1946# Usage:
1947# %cacti_import_template XMLFILE
1948# XMLFILE -- XML template to import
1949#
1950# Sample:
1951# %post
1952# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
1953#
1954# Requires: cacti >= 0.8.7e-8
1955# BuildRequires: rpmbuild(macros) >= 1.554
1956
1957%cacti_import_template() {\
1958/usr/share/cacti/cli/import_template.php --filename=%1 || :; \
1959}%{nil}
1960
cdb82983
JK
1961# pre/post script for -upstart subpackages
1962#
1963# Author: Jacek Konieczny <jajcus@jajcus.net>
1964#
1965# Usage:
1966# %upstart_post service_name
1967# %upstart_postun service_name
1968#
1969# Sample:
1970# %post upstart
1971# %upstart_post %{name}
1972#
1973# %postun upstart
1974# %upstart_postun %{name}
1975#
1976# Requirements:
1977# BuildRequires: rpmbuild(macros) >= 1.560
1978# Requires: rc-scripts >= 0.4.3
1979
1980# migrate from init script to upstart job
c4c1a53f 1981%upstart_post() \
d70efb72
ER
1982 if [ -f /var/lock/subsys/%1 ]; then \
1983 /sbin/service --no-upstart %1 stop \
1984 /sbin/service %1 start \
cdb82983
JK
1985 fi
1986
1987# restart the job after upgrade or migrate to init script on removal
1988# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
1989# at this point
c4c1a53f 1990%upstart_postun() \
d70efb72
ER
1991 if [ -x /sbin/initctl ] && /sbin/initctl status %1 2>/dev/null | grep -q 'running' ; then \
1992 /sbin/initctl stop %1 >/dev/null 2>&1 \
1993 [ -f /etc/rc.d/init.d/%1 -o -f /etc/init/%1.conf ] && { echo -n "Re-"; /sbin/service %1 start; }; \
cdb82983
JK
1994 fi
1995
7982022e 1996# EOF
This page took 0.615378 seconds and 4 git commands to generate.